#include <iostream>
#include <bits/stdc++.h>
using namespace std;
int bit_width(ll x){
    for(int i=31;i>=0;i--){
        if(x&(1<<i){
            return i;
        })
    }

}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    ll n,q;
    cin>>n>>q;
    vector<ll>a(n);
    for(int i=0;i<n;i++){
        cin>>a[i];
        mat[i][bit_width(a[i])]=1;
    }
    while(q--){
        ll l,r;
        cin>>l>>r;
        l--;
        r--;
        for(int j=0;j<32;j++){
            
        ll tr=0;
            for(int i=l;i<=r;i++){
                tr +=mat[i][j];
            }
            maxi=max(tr,maxi);
        }
        cout<<maxi;
    }
}